///////////////////////////////////////////////////////////////////////////////
/*
 * abpl.c
 *
 * The ActivityBot program.
 * http://forums.parallax.com/showthread.php/150107-My-ActivityBot?p=1208370&viewfull=1#post1208370
 * 
 */

#include "simpletools.h"
#include "abdrive.h"
#include "simpletext.h"
#include "ping.h"
#include "fdserial.h"
#include "sonyremote.h"


volatile unsigned int IRpin = 9;

//static volatile char xbInBuf[40];
static volatile int xbCog;
static volatile int speedLeft = 0;
static volatile int speedRight = 0;
static volatile int roamcmd;
static volatile int speedLeftOld = 0;
static volatile int speedRightOld = 0;


serial *xbee;

// Function prototype
int IR_remote(int irPin);
int XB_remote(void);
void ab_nav(void);
void global_Roam(void);


///////////////////////////////////////////////////////////////////////////////
int main()
{
  // Add startup code here.
  char inBuff[40];
//  int getBuff;
  char getBuff;

  pause(300);
  print("The ActivityBot\r");

/*                     Rx  Tx mode BAUD */
  xbee = fdserial_open(11, 10, 0, 9600);
  pause(500);
  writeStr(xbee,"XBremote started.\n");
  writeStr(xbee,"> ");

  int roamcmdOld = roamcmd;
  int speedLold2 = speedLeft;
  int speedRold2 = speedRight;

  int key = -1, xbcmd = -1;

  low(26);

  while(1)
  {
    key = IR_remote(9);
    xbcmd = XB_remote();
    if(xbcmd == 1) global_Roam();
    ab_nav();
  }
}
///////////////////////////////////////////////////////////////////////////////
/* IR remote control */
int IR_remote(int irPin)
{
  //toggle(26);
  int key;
  ir_tLimit(50);

  key = ir_key(irPin);
  if(key == PWR)
  {
    speedLeft = 0;
    speedRight = 0;
  }
  if(key == CH_UP)  // CH_UP -> Forward
  {
    speedLeft = 32;
    speedRight = 32;
  }
  if(key == CH_DN)  // CH_DN -> Backward
  {
    speedLeft = -32;
    speedRight = -32;
  }
  if(key == VOL_UP)  // VOL_UP -> Right
  {
    speedLeft = 16;
    speedRight = 0;
  }
  if(key == VOL_DN)  // VOL_DN -> Left
  {
    speedLeft = 0;
    speedRight = 16;
  }
  //pause(100);
  //toggle(26);
  //pause(100);
  return key; 
}
///////////////////////////////////////////////////////////////////////////////
/* XB remote control */
int XB_remote()
{
  high(27);
  char inBuff[40];
  int retval = 0;

  if(fdserial_rxReady(xbee))
  {    
    readStr(xbee, inBuff, 40);
    writeStr(xbee,"> ");
    if(!strcmp(inBuff,"onled"))
    {
      high(26);
    }
    else if(!strcmp(inBuff,"offled"))
    {
      low(26);
    }
    else if(!strcmp(inBuff,"gostop"))
    {
      speedLeft = 0;
      speedRight = 0;
    }
    else if(!strcmp(inBuff,"gofore"))
    {
      speedLeft = 32;
      speedRight = 32;
    }
    else if(!strcmp(inBuff,"goback"))
    {
      speedLeft = -32;
      speedRight = -32;
    }
    else if(!strcmp(inBuff,"goright"))
    {
      speedLeft = 16;
      speedRight = 0;
    }
    else if(!strcmp(inBuff,"goleft"))
    {
      speedLeft = 0;
      speedRight = 16;
    }
    else if(!strcmp(inBuff,"startroam"))
    {
      retval = 1;
    }
    else if(!strcmp(inBuff,"stoproam"))
    {
      retval = 2;
      speedLeft = 0;
      speedRight = 0;
    }
    else
    {
      writeLine(xbee,"Invalid Command!");
      retval = -1;
    }   
  }

  low(26);
  return retval; 
}
///////////////////////////////////////////////////////////////////////////////
void ab_nav(void)
{
  if(speedLeftOld != speedLeft || speedRightOld != speedRight)
  {
    drive_speed(speedLeft, speedRight);
    speedLeftOld = speedLeft;
    speedRightOld = speedRight;
  } 
  pause(20);
}

///////////////////////////////////////////////////////////////////////////////

void global_Roam(void)
{
  int turn;
  roamcmd = 0;
  while(1)
  {
    if(XB_remote() == 2)
      return;
    else
    {
      speedLeft = 32;
      speedRight = 32;
      ab_nav();
      pause(100);
      while(ping_cm(8) >= 20)
      {
        pause(5);
        if(XB_remote() == 2) return;
      }
      if(XB_remote() == 2) return;

      turn = rand() % 2;
      if(turn == 1)

      {
        speedLeft = 16;
        speedRight = -16;
      }
      else
      {
        speedLeft = -16;
        speedRight = 16;
      }
      ab_nav();
      while(ping_cm(8) < 20);
      {
        pause(5);
        if(XB_remote() == 2) return;
      }
    }
    /*
    else
    {
      high(27);
      pause(500);
      low(27);
      pause(500);
    }
    */
  } 
}